import bpy, math
from ast import parse

from .. rpy import RpyInterpreter

interpreter = RpyInterpreter()
interpreter.init()
interpreter.attrs_visit = None

NAMESPACE = {
    'bpy': bpy,
    'acos': math.acos,
    'acosh': math.acosh,
    'asin': math.asin,
    'asinh': math.asinh,
    'atan': math.atan,
    'atan2': math.atan2,
    'atanh': math.atanh,
    'cbrt': math.cbrt,
    'ceil': math.ceil,
    'comb': math.comb,
    'copysign': math.copysign,
    'cos': math.cos,
    'cosh': math.cosh,
    'degrees': math.degrees,
    'dist': math.dist,
    'e': math.e,
    'erf': math.erf,
    'erfc': math.erfc,
    'exp': math.exp,
    'exp2': math.exp2,
    'expm1': math.expm1,
    'fabs': math.fabs,
    'factorial': math.factorial,
    'floor': math.floor,
    'fmod': math.fmod,
    'frexp': math.frexp,
    'fsum': math.fsum,
    'gamma': math.gamma,
    'gcd': math.gcd,
    'hypot': math.hypot,
    'inf': math.inf,
    'isclose': math.isclose,
    'isfinite': math.isfinite,
    'isinf': math.isinf,
    'isnan': math.isnan,
    'isqrt': math.isqrt,
    'lcm': math.lcm,
    'ldexp': math.ldexp,
    'lgamma': math.lgamma,
    'log': math.log,
    'log10': math.log10,
    'log1p': math.log1p,
    'log2': math.log2,
    'modf': math.modf,
    'nan': math.nan,
    'nextafter': math.nextafter,
    'perm': math.perm,
    'pi': math.pi,
    'pow': math.pow,
    'prod': math.prod,
    'radians': math.radians,
    'remainder': math.remainder,
    'sin': math.sin,
    'sinh': math.sinh,
    'sqrt': math.sqrt,
    'tan': math.tan,
    'tanh': math.tanh,
    'tau': math.tau,
    'trunc': math.trunc,
    'ulp': math.ulp,

    'abs': abs,
    'all': all,
    'any': any,
    'ascii': ascii,
    'bin': bin,
    'callable': callable,
    'chr': chr,
    'dir': dir,
    'divmod': divmod,
    'format': format,
    'getattr': getattr,
    'hasattr': hasattr,
    'hash': hash,
    'hex': hex,
    'id': id,
    'isinstance': isinstance,
    'issubclass': issubclass,
    'iter': iter,
    'len': len,
    'max': max,
    'min': min,
    'next': next,
    'oct': oct,
    'ord': ord,
    'pow': pow,
    'repr': repr,
    'round': round,
    'sorted': sorted,
    'sum': sum,
    'bool': bool,
    'memoryview': memoryview,
    'bytearray': bytearray,
    'bytes': bytes,
    'complex': complex,
    'dict': dict,
    'enumerate': enumerate,
    'filter': filter,
    'float': float,
    'frozenset': frozenset,
    'property': property,
    'int': int,
    'list': list,
    'map': map,
    'range': range,
    'reversed': reversed,
    'set': set,
    'slice': slice,
    'str': str,
    'tuple': tuple,
    'type': type,
    'zip': zip,
}

def calc_py_exp(s, globals=None):
    interpreter.env = NAMESPACE.copy()  if globals is None else NAMESPACE | globals

    try:
        return interpreter.visit(parse(f'_out = {s}'))['_out']
    except: return None
